#ifndef __LIST_H__
#define __LIST_H__

/*** define data struct ***/
typedef struct tag_LIST_NODE {
	void *record;
	struct tag_LIST_NODE *r_link;
	struct tag_LIST_NODE *l_link;
} LIST_NODE;

typedef struct tag_LIST {
	int node;
	LIST_NODE *head;
	LIST_NODE *tail;
	int (*compare)(const void *, const void *);
} LIST;

/*** global function prototype ***/
LIST *list_new(int (*compare)(const void *, const void *));
void list_delete(LIST *list);
LIST *list_insert_node(LIST *list, const void *record);
LIST *list_del_node(LIST *list, void *record);
LIST_NODE *list_search(LIST *list, const void *record);
int list_size(LIST *list);

#endif
